<template>
  <div class="flex flex-col">
    <Header />
    <section
      class="
        flex flex-col
        w-full
        full-h-screen
        justify-center
        items-center
        pt-10
      "
    >
      <form @submit.prevent="createProduct">
        <div class="mb-5">
          <label class="font-bold mr-2">{{ $t("Title") }}</label>
          <input
            :placeholder="$t('Your title')"
            v-model="product.title"
            class="
              border border-solid border-gray-200
              p-3
              rounded-md
              focus:outline-none
            "
            type="text"
          />
        </div>
        <div class="mb-5">
          <label class="font-bold mr-2">{{ $t("Price") }}</label>
          <input
            :placeholder="$t('Your price')"
            v-model="product.price"
            class="
              border border-solid border-gray-200
              p-3
              rounded-md
              focus:outline-none
            "
            type="number"
          />
        </div>
        <div class="mb-5">
          <label class="font-bold mr-2">{{ $t("Category") }}</label>
          <select
            v-model="product.category"
            class="
              border border-solid border-gray-200
              p-3
              rounded-md
              focus:outline-none
            "
          >
            <option disabled value="">{{ $t("Choisissez") }}</option>
            <option
              v-for="(category, i) in categories"
              :key="`${i}-${category}`"
            >
              {{ category }}
            </option>
          </select>
        </div>
        <div class="mb-5 w-full h-auto flex flow-col">
          <label class="font-bold mr-2">{{ $t("Description") }}</label>
          <textarea
            v-model="product.description"
            class="
              border border-solid
              w-full
              h-96
              border-gray-200
              p-3
              rounded-md
              focus:outline-none
            "
          ></textarea>
        </div>
        <div class="mb-5">
          <label class="font-bold mr-2">{{ $t("Image") }}</label>
          <input
            class="
              border border-solid border-gray-200
              p-3
              focus:outline-none
              rounded-md
            "
            type="file"
            @change="onFileChange"
          />
        </div>
        <button
          :class="
            !$v.$invalid
              ? 'bg-blue-200 hover:bg-blue-400'
              : 'pointer-events-none bg-gray-100 text-gray-400'
          "
          class="font-bold px-5 py-3 rounded-md"
        >
          Save
        </button>
      </form>
    </section>
    <Footer />
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { Component } from "vue-property-decorator";
import axios from "axios";
import Header from "./_includes/Header.vue";
import Footer from "./_includes/Footer.vue";
import {
  required,
  minLength,
  maxLength,
  minValue,
} from "vuelidate/lib/validators";
import { Product } from "@/types/product";

@Component({
  components: {
    Header,
    Footer,
  },
  validations: {
    product: {
      title: {
        required,
        minLength: minLength(2),
      },
      price: {
        required,
        minValue: minValue(1),
      },
      description: {
        maxLength: maxLength(200),
      },
    },
  },
})
export default class CreateProduct extends Vue {
  private product: Product = {
    title: "",
    price: 0,
    category: "",
    description: "",
    image: "",
  };
  private image = null;
  private categories: string[] = [];

  private onFileChange(e: any): void {
    this.product.image = e.target.files[0];
  }

  private async createProduct(): Promise<void> {
    try {
      await axios.post(`https://fakestoreapi.com/products/`, this.product);
    } catch (e) {
      console.log(e);
    }
  }

  private async created(): Promise<void> {
    try {
      this.categories = (
        await axios.get("https://fakestoreapi.com/products/categories")
      ).data;
    } catch (e) {
      console.log(e);
    }
  }
}
</script>
